con

OneSecond = 80_000_000
PUTCHAR = 0 ' writing hub memory address 0 will output a char to the cog emulators console

pub xx
  cognew(@start0,0) 'dummy command

DAT

'########################## COG0 ###################################################
magicNumber0
        long    $55AA1133   'magic number as starting point for the cog emulator

        org     0
start0
        shl startadr,#4
        add startadr,#1 'cog1
        coginit startadr
        waitcnt timer0,delay0
        'cogstop 1
end0
        jmp #end0

delay0  long OneSecond*3
startadr long $3C
timer0 res 1
        fit 496

'####################### COG1 #########################################################
magicNumber1
        long    $55AA1134   'magic number as starting point for the cog emulator

        org     0
start
        mov r0,#$00 'clear screen command
        wrbyte r0,#PUTCHAR

        movs printText,#hello
        call #printText
:loop
   if_c jmp #:exit
        mov r0,#$0c 'color command
        wrbyte r0,#PUTCHAR
        'mov r0,#$0
        wrbyte counter,#PUTCHAR  'color

        movs printText,#propText
        call #printText

        djnz counter,#:loop wz,wc
        jmp #:loop ' jump for the last zero
:exit
        mov r0,#$0c 'color command
        wrbyte r0,#PUTCHAR
        mov r0,#8 'all attributes off, not a vga_text.spin command
        wrbyte r0,#PUTCHAR

numberLoop
        waitcnt timer,delay
        movs printText,#text
        call #printText
        jmp #numberLoop

'###############################################################
printText

:loop
        mov r0,0

        mov r1,r0
        and r1,#$ff wz
   if_z jmp #:exit
        wrbyte r0,#PUTCHAR

        shr r0,#8
        mov r1,r0
        and r1,#$ff wz
   if_z jmp #:exit
        wrbyte r0,#PUTCHAR

        shr r0,#8
        mov r1,r0
        and r1,#$ff wz
   if_z jmp #:exit
        wrbyte r0,#PUTCHAR

        shr r0,#8
        mov r1,r0
        and r1,#$ff wz
   if_z jmp #:exit
        wrbyte r0,#PUTCHAR

        add printText,#1 'increment source address
        jmp #:loop

:exit
printText_ret
        ret

hello
        byte $0a,10,$0b,5,"hello",13,13,13,0
x2 long 1

propText
        byte "this text is generated by propeller code!",$0c,7,13,0

x1 long $FFFF0000
'zero long 0
text
        byte "1234567",13,0

delay  long OneSecond

counter long 8
timer res 1
r0 res 1
r1 res 1

        fit 496
